/*	
 *	clipsn7.c
 *
 *	P/ECE SN76489/SN76496 Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Mon Jan 12 18:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"

/****************************************************************************
 *	
 ****************************************************************************/

void
sn76489_reset(SN76489* sn, int clock)
{
	memset(sn, 0, sizeof(SN76489));

	/* NbNisDDAZbgAbvB */
	sn->progress.u = clock / SPEAKER_FREQUENCY;	/* ̕ω */
	sn->progress.n = clock % SPEAKER_FREQUENCY;	/* [̑ */
	sn->progress.d =        -SPEAKER_FREQUENCY;	/* [ */
}

void
sn76489_write(SN76489* sn, unsigned char data)
{
	SN76489TONE* tone;
	SN76489NOISE* noise;
	int i_channel;

	if(data & 0x80) {
		// data: 76543210
		//       ||||++++- [3:0]/
		//       |||+----- 0:[3:0]ݒ/1:ʐݒ
		//       |++------ `lԍ(0-2:g[/3:mCY)
		//       +-------- 1
		i_channel = sn->latch_channel = (data >> 5) & 3;
		if(i_channel <= 2) {
			tone = &sn->tone[i_channel];
			if(data & 0x10) {
				/*  (炩ߔ]Ă܂) */
				tone->volume = ~data & 0xf; /* ] */
			} else {
				/* [3:0] (炩16{Ă܂) */
				tone->period = (((tone->period >> 4) & ~0xf) | (data & 0xf)) << 4;
			}
		} else {
			noise = &sn->noise;
			if(data & 0x10) {
				/*  (炩ߔ]Ă܂) */
				noise->volume = ~data & 0xf; /* ] */
			} else {
				/*  (炩16{Ă܂) */
				/* periodl͂̓{? vmF */
				switch(data & 3) {
#if 0
				case 0:  noise->period = 0x10 << 4; break;
				case 1:  noise->period = 0x20 << 4; break;
				case 2:  noise->period = 0x40 << 4; break;
#else				/*ǂH(ۂ)*/
				case 0:  noise->period = 0x20 << 4; break;
				case 1:  noise->period = 0x40 << 4; break;
				case 2:  noise->period = 0x80 << 4; break;
#endif
				default: noise->period = 0x00 << 4; break; /* tone[2].period g */
				}
				noise->feedback = data & 4 ? SN76489NOISE_WHITE     /* 1:zCgmCY */
							   : SN76489NOISE_PERIODIC; /* 0:mCY */
				noise->lfsr = 1; /* mCỸf[eB1:15ۏ؂邽߂ɕKv */
			}
		}
	} else {
		// data: 76543210
		//       ||++++++- [9:4]
		//       |+------- (gp)
		//       +-------- 0
		i_channel = sn->latch_channel;
		if(i_channel <= 2) {
			tone = &sn->tone[i_channel];
			/* [9:4] */
			tone->period = (((tone->period >> 4) & 0xf) | ((data & 0x3f) << 4)) << 4;
		}
	}
}

