/*	
 *	clipssmi.h
 *
 *	P/ECE S-SMP (SPC700) Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Sun Jan 04 21:33:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_SSMI_H__
#define __CLIP_SSMI_H__

/*
 *	SSMPRAp̃}N`܂B
 *	}NPāȂ̃}NƏՓ˂鋰ꂪ̂ŁA
 *	SSMPRA\[Xt@Ĉ݃CN[hĂB
 */

/****************************************************************************
 *
 ****************************************************************************/

/*
 *	SSMP\̃oANZX̊ȗ\L
 */
/*===== WX^ =====*/
#define PC		(ssmp->pc)
#define A		(ssmp->a)
#define X		(ssmp->x)
#define Y		(ssmp->y)
#define SP		(ssmp->sp)
#define PSW		(ssmp->psw)
/*=====  =====*/
#define CYCLE		(ssmp->cycle)
#define SLEEP		(ssmp->sleep)
/*===== O֐ =====*/
#define READ(a)		    ((ssmp->read )(ssmp, (unsigned short)(a)))
#define WRITE(a, n)	do { (ssmp->write)(ssmp, (unsigned short)(a), (unsigned char)(n)); } while(0)

/****************************************************************************
 *
 ****************************************************************************/

/*
 *	16rbgWX^̏/8rbgANZX
 */
#define LO(nn)		(*(((unsigned char*)&(nn)) + 0))
#define HI(nn)		(*(((unsigned char*)&(nn)) + 1))
#define PCL		LO(PC)
#define PCH		HI(PC)

/*
 *	16rbgANZX
 */
#define READ16(a)	(READ(a) | READ((a) + 1) << 8)
#define WRITE16(a, nn)	do { WRITE(a, LO(nn)); WRITE((a) + 1, HI(nn)); } while(0)

/*
 *	PUSH/POP
 */
#define PUSH(r)		do {       WRITE(0x0100 | SP, (r)); SP--; } while(0)
#define POP(r)		do { SP++; (r) = READ(0x0100 | SP);       } while(0)

/*
 *	CXgNVtFb`/s
 */
#define FETCH(n)	do {		\
	(n) = READ(PC++);		\
	SSMPTRACE("%02x ", (n));	\
} while(0)
#define EXEC()		do {					\
	SSMPTRACE("[%s]", &ssmp_op_name_table[op->name]);	\
	op->proc(ssmp, code, arg1, arg2);			\
	CYCLE -= op->cycle;					\
} while(0)

#endif /*__CLIP_SSMI_H__*/
