/*	
 *	framp62.c
 *
 *	P/ECE HuC6280-PSG Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Mon Feb 23 04:28:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"

/****************************************************************************
 *	֐
 ****************************************************************************/

/* `lo:t20bit ~ 6`l  t22.6bit */
int
huc6280psg_process(HUC6280PSG* psg, int cycle)
{
	return huc6280psg_channel_process(psg, &psg->channel[0], cycle)
	     + huc6280psg_channel_process(psg, &psg->channel[1], cycle)
	     + huc6280psg_channel_process(psg, &psg->channel[2], cycle)
	     + huc6280psg_channel_process(psg, &psg->channel[3], cycle)
	     + huc6280psg_channel_process(psg, &psg->channel[4], cycle)
	     + huc6280psg_channel_process(psg, &psg->channel[5], cycle);
}

/* g`f[^:t5bit ~ `l{[:15bit  t20bit */
int
huc6280psg_channel_process(HUC6280PSG* psg, HUC6280PSGCHANNEL* channel, int cycle)
{
	char sample;

	if(!channel->enable) return 0;

	if(!channel->dda) {
		if(!channel->noise) { /* Tone mode */
			channel->tone_progress -= cycle;
			while(channel->tone_progress <= 0) {
				channel->tone_progress += channel->tone_period;
				channel->tone_index++;
			}
			sample = channel->wave[channel->tone_index & 0x1f];

		} else { /* Noise mode */
			channel->noise_progress -= cycle;
			while(channel->noise_progress <= 0) {
				channel->noise_progress += channel->noise_period;
				/* @̓̎dl킩Ȃ̂ŁA[9bit tap=0x11]Mn񗐐gƂɂ܂B */
				channel->noise_lfsr = (channel->noise_lfsr >> 1) |
						    (((channel->noise_lfsr >> 0) ^ (channel->noise_lfsr >> 4)) & 1) << 8;
			}
			sample = channel->noise_lfsr & 1 ? 15 : -16;
		}

	} else { /* Direct D/A mode */
		sample = channel->wave[0];
	}

	return sample * channel->volume; /* AZúAshort~shortō */
}

